import {
  Column,
  Entity,
  JoinColumn,
  ManyToOne,
  OneToOne,
  PrimaryGeneratedColumn,
} from 'typeorm';
import { InstitucionInfraccion } from '../../institucion-infraccion/entity/institucion-infraccion.entity';
import { Prestamo } from '../../prestamo/entity/prestamo.entity';
import { Operador } from '../../operador/entity/operador.entity';

@Entity()
export class Multa {
  @PrimaryGeneratedColumn()
  id_multa: number;

  @Column({ type: Boolean, nullable: false, default: true })
  activo: boolean;

  @Column({ type: Date, nullable: false })
  fecha_fin: Date;

  @Column({ type: Date, nullable: false })
  fecha_inicio: Date;

  @Column({ type: Boolean, nullable: false })
  retraso: boolean;

  @ManyToOne(
    () => InstitucionInfraccion,
    (institucionInfraccion) => institucionInfraccion.multas,
    { eager: true },
  )
  @JoinColumn({ name: 'id_institucion_infraccion' })
  institucionInfraccion: InstitucionInfraccion;

  @ManyToOne(() => Operador, (operador) => operador.multas, { eager: true })
  @JoinColumn({ name: 'id_operador' })
  opeardorMulta: Operador;

  @OneToOne(() => Prestamo)
  prestamo: Prestamo;
}
